############################################################
#################### Quizzo Version 1.0 ####################
############################################################

# Requirements:
# EventScripts 2.1 (Orange Box) or later

############################################################
############################################################
############################################################

import es, playerlib, popuplib, cfglib, gamethread
import random

info = es.AddonInfo()
info.name = 'Quizzo'
info.version = '1.0'
info.url = 'http://addons.eventscripts.com/addons/view/quizzo'
info.author = 'Lumpi@Work'
info.description = 'Quizzes for CS:S'

es.set("quizzo_ver", 1.0)
es.makepublic("quizzo_ver")

es.msg("#multi", "#green[Quizzo]#default: #lightgreenLoaded - Made by Lump1")

quizzoconfig = cfglib.AddonCFG(es.getAddonPath("quizzo") + "/quizzo.cfg")
quizzo_interval = quizzoconfig.cvar("quizzo_interval", 0)
quizzo_min_players = quizzoconfig.cvar("quizzo_min_players", 0)
quizzo_timelimit = quizzoconfig.cvar("quizzo_timelimit", 0)
quizzo_reward_cash = quizzoconfig.cvar("quizzo_reward_cash", 0)
quizzo_reward_item = quizzoconfig.cvar("quizzo_reward_item", 0) 
quizzo_reward_health = quizzoconfig.cvar("quizzo_reward_health", 0)
quizzo_reward_speed = quizzoconfig.cvar("quizzo_reward_speed", 0)
quizzo_punish_cash = quizzoconfig.cvar("quizzo_punish_cash", 0)
quizzo_punish_strip = quizzoconfig.cvar("quizzo_punish_strip", 0) 
quizzo_punish_health = quizzoconfig.cvar("quizzo_punish_health", 0)
quizzo_punish_speed = quizzoconfig.cvar("quizzo_punish_speed", 0)
quizzo_possible_solutions = quizzoconfig.cvar("quizzo_possible_solutions", 0)
quizzo_min_number = quizzoconfig.cvar("quizzo_min_number", 0)
quizzo_max_number = quizzoconfig.cvar("quizzo_max_number", 0)
quizzo_operator = quizzoconfig.cvar("quizzo_operator", 0)
quizzo_stats = quizzoconfig.cvar("quizzo_stats", 0)
		
def load():
    quizzoconfig.execute()
    global roundcounter
    roundcounter = 0
    global timeover
    timeover = 0
    es.regsaycmd("!quizzo", "quizzo/setting", "switch quizzo on/off")
    if quizzo_stats:
        es.regsaycmd("!quizzostats", "quizzo/stats", "show your quizzo stats")
        es.regsaycmd("!quizzodel", "quizzo/delstats", "delete your quizzo stats")
        es.sql('open','quizzo_stats','|quizzo')
        es.sql('query','quizzo_stats',"CREATE TABLE IF NOT EXISTS stats (playerid TEXT, setting INTEGER DEFAULT '0', total INTEGER DEFAULT '0', right INTEGER DEFAULT '0', wrong INTEGER DEFAULT '0')")
        
def unload():
    if quizzo_stats:
        es.unregsaycmd("!quizzostats")
        es.unregsaycmd("!quizzodel")
        global statspopup
        if popuplib.exists("statspopup"):
            statspopup.delete()  
        es.sql('close','quizzo_stats')
    es.unregsaycmd("!quizzo")
    es.msg("#multi", "#green[Quizzo]#default: #lightgreenUnloaded")
    
def createquiz(solutions, min_number, max_number, operator):
    global returnlist
    global quizlist
    quizlist = []
    solutionlist = []
    op1 = random.randint(min_number, max_number)
    op2 = random.randint(min_number, max_number)
    calculate(op1, op2, operator)
    solutionlist.append(returnlist[1])
    quizlist.append(op1)
    quizlist.append(returnlist[0])
    quizlist.append(op2)
    quizlist.append(solutionlist[0])   
    for fsolution in range(1, solutions):
        op1 = random.randint(min_number, max_number)
        op2 = random.randint(min_number, max_number)
        calculate(op1, op2, operator)
        solutionlist.append(returnlist[1])    
    createmenu(quizlist, solutionlist)
    
def calculate(op1, op2, operator):
    global returnlist
    returnlist = []
    if operator == "random":
        operator = random.choice(["+", "-", "*", "/"])
        if operator == "+":
            solution = op1 + op2
        elif operator == "-":
            solution = op1 - op2
        elif operator == "*":
            solution = op1 * op2
        elif operator == "/":
            solution = op1 / float(op2)
            solution = round(solution, 2)
    elif operator == "+":
        solution = op1 + op2
    elif operator == "-":
        solution = op1 - op2
    elif operator == "*":
        solution = op1 * op2
    elif operator == "/":
        solution = op1 / float(op2)
        solution = round(solution, 2)
    returnlist.append(operator)
    returnlist.append(solution)     
    
def createmenu(quizlist, solutionlist):
    global quizzomenu  
    quizzomenu = popuplib.easymenu("quizzo", None, menuhandler)
    quizzomenu.settitle("- Quizzo -")
    quizzomenu.setdescription("\nSolve this quiz!\n%s %s %s = ?" %(quizlist[0], quizlist[1], quizlist[2]))
    random.shuffle(solutionlist)
    for solutions in solutionlist:
        quizzomenu.addoption(solutions, "%s" %solutions)          
        
def menuhandler(player, choice, menuname):
    global timeover
    if timeover == 1:
        es.tell(player, "#multi", "#green[Quizzo]#default: #lightgreenYou're too slow! (Timelimit is %s seconds)" %quizzo_timelimit)
    else:
        if quizzo_stats:
            splayerid = es.getplayersteamid(player)
        global quizlist
        if choice == quizlist[3]:
            es.tell(player, "#multi", "#green[Quizzo]#default: #lightgreenCongratulations, that's right!")
            reward(player)
            if quizzo_stats:
                es.sql('query','quizzo_stats',"UPDATE stats SET total = (total + 1) WHERE playerid='%s'" %splayerid)
                es.sql('query','quizzo_stats',"UPDATE stats SET right = (right + 1) WHERE playerid='%s'" %splayerid)
        else:
            es.tell(player, "#multi", "#green[Quizzo]#default: #lightgreenSorry, that's wrong!")
            punishments(player)
            if quizzo_stats:
                es.sql('query','quizzo_stats',"UPDATE stats SET total = (total + 1) WHERE playerid='%s'" %splayerid)
                es.sql('query','quizzo_stats',"UPDATE stats SET wrong = (wrong + 1) WHERE playerid='%s'" %splayerid)
        
def reward(player):
    quizzoplayer = playerlib.getPlayer(player)
    if quizzo_reward_cash:
        if quizzoplayer.getCash() + quizzo_reward_cash < 16000:
            quizzoplayer.add("cash", quizzo_reward_cash)
        else:
            quizzoplayer.setCash(16000)
        es.tell(quizzoplayer, "#multi", "#green[Quizzo]#default: #lightgreenYou got %s$ reward" %quizzo_reward_cash)
    if quizzo_reward_health:
        quizzoplayer.add("health", quizzo_reward_health)
        es.tell(quizzoplayer, "#multi", "#green[Quizzo]#default: #lightgreenYou got extra health!")
    if quizzo_reward_item != "0":
        gamethread.delayed(.1, es.give, (quizzoplayer, quizzo_reward_item))
        es.tell(quizzoplayer, "#multi", "#green[Quizzo]#default: #lightgreenYou got an extra item!")
    if quizzo_reward_speed:
        quizzoplayer.setSpeed(1.5)
        es.tell(quizzoplayer, "#multi", "#green[Quizzo]#default: #lightgreenYou got extra speed!")
        
def punishments(player):
    quizzoplayer = playerlib.getPlayer(player)
    if quizzo_punish_cash or quizzo_punish_health or quizzo_punish_strip or quizzo_punish_speed:
        es.tell(quizzoplayer, "#multi", "#green[Quizzo]#default: #lightgreenNow you'll get punishment")    
    if quizzo_punish_cash:
        if quizzoplayer.getCash() > quizzo_punish_cash:
            quizzoplayer.cash -= quizzo_punish_cash
        else:
            quizzoplayer.setCash(0)
    if quizzo_punish_health:
        quizzoplayer.health -= quizzo_punish_health
    if quizzo_punish_strip:
        playerhasbomb = 0
        if quizzoplayer.hasC4():
            playerhasbomb = 1
        gamethread.queue(es.give, (quizzoplayer, "player_weaponstrip"))
        gamethread.queue(es.fire, (quizzoplayer, "player_weaponstrip", "strip"))
        if playerhasbomb:
            gamethread.delayed(.1, es.give, (quizzoplayer, "weapon_c4"))
        gamethread.delayed(.1, es.give, (quizzoplayer, "weapon_knife"))       
    if quizzo_punish_speed:
        quizzoplayer.setSpeed(0.6)
        
def stats():
    suserid = es.getcmduserid()
    ssteamid = es.getplayersteamid(suserid)
    stats_total = es.sql('queryvalue','quizzo_stats',"SELECT total FROM stats WHERE playerid='%s'" %ssteamid)
    stats_right = es.sql('queryvalue','quizzo_stats',"SELECT right FROM stats WHERE playerid='%s'" %ssteamid)
    stats_wrong = es.sql('queryvalue','quizzo_stats',"SELECT wrong FROM stats WHERE playerid='%s'" %ssteamid)
    global statspopup
    statspopup = popuplib.create("statspopup")
    statspopup.addline("- Quizzo Stats -")
    statspopup.addline("----------------------")
    statspopup.addline("Total answers: %s" %stats_total)    
    statspopup.addline("Right answers: %s" %stats_right)
    statspopup.addline("Wrong answers: %s" %stats_wrong)
    statspopup.addline(" ")
    statspopup.send(suserid)
    if popuplib.exists("statspopup"):
        statspopup.delete()
        
def delstats():
    suserid = es.getcmduserid()
    ssteamid = es.getplayersteamid(suserid)
    es.sql('query','quizzo_stats',"UPDATE stats SET total = 0 WHERE playerid='%s'" %ssteamid)     
    es.sql('query','quizzo_stats',"UPDATE stats SET right = 0 WHERE playerid='%s'" %ssteamid) 
    es.sql('query','quizzo_stats',"UPDATE stats SET wrong = 0 WHERE playerid='%s'" %ssteamid)
    es.tell(suserid, "#multi", "#green[Quizzo]#default: #lightgreenStats deleted")
    
def setting():
    suserid = es.getcmduserid()
    ssteamid = es.getplayersteamid(suserid)
    if es.getargs() == "1":
        es.sql('query','quizzo_stats',"UPDATE stats SET setting = 1 WHERE playerid='%s'" %ssteamid)
        es.tell(suserid, "#multi", "#green[Quizzo]#default: #lightgreenQuizzo activated")
    elif es.getargs() == "0":
        es.sql('query','quizzo_stats',"UPDATE stats SET setting = 0 WHERE playerid='%s'" %ssteamid)
        es.tell(suserid, "#multi", "#green[Quizzo]#default: #lightgreenQuizzo deactivated")
    else:
        es.tell(suserid, "#multi", "#green[Quizzo]#default: #lightgreenYou have to type '!quizzo 0' or '!quizzo 1'")               

def round_start(event_var):
    global roundcounter
    roundcounter = roundcounter + 1
    gamethread.delayed(2, sendquiz)
                
def sendquiz():
    activeplayers = []
    timelimit = 0
    global timeover
    timeover = 0
    global roundcounter
    if roundcounter == quizzo_interval:
        roundcounter = 0 
        playerlist = playerlib.getPlayerList("#alive, #human")
        if playerlist:
            for player in playerlist:
                playercount = 0
                playerid = es.getplayersteamid(player)
                playercheck = es.sql('queryvalue','quizzo_stats',"SELECT setting FROM stats WHERE playerid='%s'" %playerid)
                if playercheck == "1":
                    playercount = playercount + 1
                    activeplayers.append(player)
            if playercount >= quizzo_min_players:
                rplayer = random.choice(activeplayers)
                playerid = es.getplayersteamid(rplayer)
                createquiz(quizzo_possible_solutions, quizzo_min_number, quizzo_max_number, quizzo_operator)
                global quizzomenu
                quizzomenu.send(rplayer)
                if quizzo_timelimit:
                    gamethread.cancelDelayed(timelimit)
                    gamethread.delayedname(quizzo_timelimit, timelimit, reminder)

def reminder():
    global timeover
    timeover = 1
                
def player_activate(event_var):
    if quizzo_stats:
        playercheck = es.sql('queryvalue','quizzo_stats',"SELECT playerid FROM stats WHERE playerid='%s'" %event_var["es_steamid"])
        if playercheck == None:
            es.sql('query','quizzo_stats',"INSERT INTO stats (playerid, setting, total, right, wrong) VALUES ('%s', 1, 0, 0, 0)" %event_var["es_steamid"])